%3 ad hoc priklady na kvadraticky linearni problem (deterministicke rizeni)

clc
close all
clear all


%chceme ridit v casovem horizontu
T=10;
%deterministicky lin. system x_t+1=A*x_t+B*u_t+c_t
A=eye(3);
B=[1;1;2];
c=zeros(3,T);
%vzhledem ke ztratove funkci urcene maticemi
n_x=size(A,1);
n_u=size(B,2);
W=diag([100,100,100]);
F=zeros(n_x,n_u);
Lambda=0;
%pozadovanym hodnotam
x_target=zeros(n_x,1);
u_target=zeros(n_u,1);
%a pocatecnimu stavu
x_0=[10;10;10];

[u,x,K,p,v,G,g]=det_opt_control(T,W,F,Lambda,x_target,u_target,A,B,c,x_0);

figure
subplot(2,1,1)
plot(0:T,x)
legend(['x_1';'x_2'],'Location','NE')
subplot(2,1,2)
plot(0:T-1,u)
legend(['u_1'],'Location','Best')

%Cost-To-Go
J=x(:,1)'*K(:,:,1)*x(:,1)+p(:,1)'*x(:,1)+v(1)

%************************************************************************

%chceme ridit v casovem horizontu
T=50;

%maly gapovy NK makro model (viz makro_model.ps)
alpha=0.72;
beta=-0.11;
delta=0.42;
gamma=0.39;

M1=[   1      beta     0
   -delta   gamma-1   0
      0       0       1];
M2=[alpha      0      0
      0       -1    gamma
      0        1      0];
M3=[beta;0;0];

A=inv(M1)*M2;
B=inv(M1)*M3;
c= zeros(3,T); %exogenni faktor

eigenvalues=eig(A);
rho_A=max(abs(eigenvalues));% spektralni polomer  matice A (system je stabilni, podud je <1)

%vzhledem ke ztratove funkci urcene maticemi
W=[ 1  0  0
    0  0  0
    0  0 10];
    
F=[0
    0
    0];
Lambda=[5];

%pozadovanym hodnotam
x_target=zeros(3,1);
u_target=0;

%a pocatecnimu stavu
x_0=[5
     -2
     0];

%reseni 
[u,x,K,p,v,G,g]=det_opt_control(T,W,F,Lambda,x_target,u_target,A,B,c,x_0);

%vykresleni vysledku
figure
subplot(2,1,1)
plot((0:T),x)
legend(strvcat('y_t','\pi_{t+1}','\pi_t'),'Location','SE')
subplot(2,1,2)
plot((0:T-1),u)
legend(['i_t'],'Location','Best')

%Cost-To-Go
J=x(:,1)'*K(:,:,1)*x(:,1)+p(:,1)'*x(:,1)+v(1)

%**************************************************************************

%chceme ridit v casovem horizontu
T=7;

%deterministicky lin. system x_t+1=A*x_t+B*u_t+c_t
A=[1.014 0.002
   0.093 0.753];
B=[-0.004
   -0.1];
c=[-1.312
    0.448];
c=c*ones(1,T);


%vzhledem ke ztratove funkci urcene maticemi
W_T=[100   0
      0   100];
W_k=[1 0
     0 1];
F_k=[0
     0];
Lambda_k=[1];

%pozadovanym hodnotam
x_target=zeros(2,T+1);
for k=1:T+1
    x_target(:,k)=1.0075^(k-1)*[460.1;113.1];
end
      

u_target=zeros(1,T);
for k=1:T
    u_target(:,k)=1.0075^(k-1)*[153.644];
end

%a pocatecnimu stavu
x_0=[460.1 113.1]';

%reseni 
[u,x,K,p,v,G,g]=det_opt_control2(T,W_T,W_k,F_k,Lambda_k,x_target,u_target,A,B,c,x_0);

%vykresleni vysledku
figure
subplot(2,1,1)
plot((0:T),[x;x_target])
legend(strvcat('spotreba','investice','spotreba cl','investice cl'),'Location','Best')
subplot(2,1,2)
plot((0:T-1),[u;u_target])
legend(strvcat('vldn vdaje','vldn vdaje cl'),'Location','Best')

%Cost-To-Go
J=x(:,1)'*K(:,:,1)*x(:,1)+p(:,1)'*x(:,1)+v(1)
